#!/usr/bin/python

# raspbian startup time with fewer services
# 0m49.723s  
# 0m49.856s
# original jessie startup time to start a lightdm desktop:
# 1m12
# volgens systemd-analyse
# Startup finished in 2.084s (kernel) + 26.747s (userspace) = 28.831s
# na een dedicated xinit-login.service die alleen op het touchscreen wacht:
# xinit-login.service @11.358s
# handmatige timing: 0m28.588s 

# en nu met readonly fs 0m31.8
# xinit-login.service @10.384s

#$ systemd-analyze 
#Startup finished in 2.096s (kernel) + 17.584s (userspace) = 19.680s



from gi.repository import Gtk, Gdk, GObject, GdkPixbuf, GLib
import socket
import urllib
import re
import subprocess
import sys
import threading
import Queue
import time
import os
import errno
import fcntl
import struct
import urllib
import collections
import logging

#logging.basicConfig(filename='sqgui2.log',filemode='w',format='%(filename)s:%(lineno)d:%(funcName)s:%(message)s',level=logging.INFO)
logging.basicConfig(format='%(filename)s:%(lineno)d:%(funcName)s:%(message)s',level=logging.DEBUG)

execfile('config.py')

class sqstatus:
	songtime = 0.0
	reftime = 0.0
	shuffle = 0
	repeat = 0
	mode = 'pause'

	url = ''
	duration = 0.0
	song = 'song'
	album = 'album'
	artist = 'artist'
	track_id = 0
	album_id = 0
	artist_id = 0
	coverid = ''
	next_url = ''
	next_duration = 0
	next_song = ''
	next_album = ''
	next_artist = ''
	next_track_id = 0
	next_album_id = 0
	next_artist_id = 0
	next_coverid = ''
	nextrunning = 0
	
	def resetnext(self, url):
		self.next_url = url
		self.next_duration = 0
		self.next_song = ''
		self.next_album = ''
		self.next_artist = ''
		self.next_track_id = 0
		self.next_album_id = 0
		self.next_artist_id = 0
		self.nextrunning = 1
		self.next_coverid = ''
	
	def next2cur(self):
		self.url = self.next_url
		self.set_duration(self.next_duration) 
		self.song = self.next_song
		self.album = self.next_album
		self.artist = self.next_artist
		self.track_id = self.next_track_id
		self.album_id = self.next_album_id
		self.artist_id = self.next_artist_id
		self.track_id = self.next_track_id
		self.coverid = self.next_coverid

	def __init__(self):
		self.reftime = time.time()

	def update_songtime(self):
		self.songtime = time.time() - self.reftime

	def formatted_songtime(self):
		self.update_songtime()
		minutes = int(self.songtime / 60.0)
		sec = int(round(self.songtime % 60.0))
		return '%d:%02d' % (minutes,sec)

	def formatted_duration(self):
		minutes = int(self.duration / 60.0)
		sec = int(round(self.duration % 60.0))
		return '%d:%02d' % (minutes,sec)

	def set_duration(self, duration):
		try:
			self.duration = float(duration)
		except:
			self.duration = 0.0

class artwork_thread(threading.Thread):
	cache = {}
	cachesize = 0
	maxcachesize = 81920000 # 80 mb
	set_coverid = ''
	
	def __init__(self, artwork_handler):
		self.artwork_handler = artwork_handler
		self.queue = Queue.Queue()
		self.cache = collections.OrderedDict()
		self.cachesize = 0
		threading.Thread.__init__ (self)
		self.daemon = True
		logging.info('artwork thread ready for start')
		
	def cache_put(self,coverid, imgdata):
		self.cache[coverid] = imgdata
		self.cachesize = self.cachesize + len(imgdata)
		if (self.cachesize > self.maxcachesize):
			logging.info('artwork thread cleanup last item from cache, current size=%d'%self.cachesize)
			data = self.cache.popitem(last=False) # since we use an ordereddict the order is rememberd. It can pop FIFO (last=True) of LIFO (last=False)
			self.cachesize = self.cachesize - len(data)
	
	def cache_get(self,coverid):
		data = self.cache[coverid]
		# now move the item to the end
		del self.cache[coverid]
		self.cache[coverid] = data
		return data
		
	def run(self):
		while (True):
			logging.debug('artwork thread waiting...')
			#filename = "/tmp/artwork.jpg"
			coverid = self.queue.get()
			while (coverid in self.cache):
				coverid = self.queue.get()
			if (coverid!='None'):
				url = 'http://'+config['server_ip']+':9000/music/'+coverid+'/cover.jpg'
			else:
				url = 'http://'+config['server_ip']+':9000/music/current/cover.jpg?player='+config['player']
			logging.info('artwork coverid=%s open %s'%(coverid,url))
			resource = urllib.urlopen(url)
			imgdata = resource.read()
			self.cache_put(coverid,imgdata)
			logging.debug('artwork_thread.run(), got %d bytes of imgdata, cachesize is %d'% (len(imgdata),self.cachesize))
			self.queue.task_done()
			if (self.set_coverid == coverid):
				GLib.idle_add(self.artwork_handler,imgdata);
				self.set_coverid = ''

	def retrieve_next_cover(self, coverid):
		logging.info('coverid=%s'%coverid)
		if not coverid:
			coverid = 'None'
		if (coverid not in self.cache):
			self.queue.put(coverid)

	def set_cover(self, coverid):
		logging.info('coverid=%s'%coverid)
		if not coverid:
			coverid = 'None'
		if (coverid in self.cache):
			imgdata = self.cache_get(coverid)
			logging.info('got coverid %s from cache'%coverid)
			GLib.idle_add(self.artwork_handler,imgdata);
		else:
			self.queue.put(coverid)
			self.set_coverid = coverid
			if ('None' in self.cache):
				# until we have the final cover, set the 'None' cover in the GUI
				imgdata = self.cache_get('None')
				GLib.idle_add(self.artwork_handler,imgdata);

class lms_thread(threading.Thread):
	sock = False
	receivebuf = None
	
	def handle_data(self,data):
		#print 'lms_thread handle_data',data
		nonewline = False
		ndata = urllib.unquote(data).decode('utf8')
		if (self.receivebuf):
			ndata = self.receivebuf+ndata
			self.receivebuf = None
		if (ndata[-1:] != '\n'):
			logging.debug('data does not end on a newline!!!!')
			nonewline = True
		lines = ndata.split('\n')
		lineslen = len(lines)
		#print 'have ',lineslen,'lines in ndata'
		if (nonewline):
			self.receivebuf = lines[lineslen-1]
			lineslen = lineslen - 1
		for i in range(0,lineslen):
			if (lines[i] != ""):
				GLib.idle_add(self.line_handler,(self.lms_type, lines[i]));
	
	def reconnect(self):
		cont_connect = 1
		while (cont_connect):
			if (self.sock):
				self.sock.close()
			self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			self.sock.settimeout(3.0)
			try:
				logging.warning('(re)connect to %s:%d'%(config['server_ip'],config['server_port']))
				self.sock.connect((config['server_ip'],config['server_port']))
				cont_connect = 0
			except socket.error as sockerr:
				logging.warning('socket error %d:%s, try again in 1.0 second'%(sockerr.errno,str(sockerr)))
				# 113 = no route to host
				# 110 = connection timed out
				if (sockerr.errno == 113 or sockerr.errno == 110):
					logging.debug('NEED SSH HANDLER')
					self.need_ssh_handler()
				time.sleep(1.0)

	def listenloop_reconnect(self):
		self.reconnect()
		self.sock.settimeout(None)
		self.sock.sendall('listen 1\n')

	def listenloop(self):
		self.sock.settimeout(None)
		self.sock.sendall('listen 1\n')
		while (True):
			try:
				logging.debug('read from server...')
				data = self.sock.recv(40960)
				if (len(data)==0):
					logging.debug('0 bytes of data')
					self.listenloop_reconnect()
				else:
					self.handle_data(data)
			except socket.error as sockerr:
				logging.warning('error'+str(sockerr))
				self.listenloop_reconnect()
		logging.info('finished, thread finished')

	def commandloop(self):
		logging.debug('waiting for commands...')
		while (True):
			try:
				data = self.queue.get(True, 1)
			except Queue.Empty:
				data = ''
			if (data != ''):
				try:
					logging.debug('send "'+data[:-1]+'" to server')
					self.sock.settimeout(5.0)
					self.sock.sendall(data)
				except socket.timeout as sockerr:
					logging.warning('timeout sending to server !!!!!!!')
				except socket.error as sockerr:
					logging.warning('send error'+str(sockerr))
					self.reconnect()
				self.queue.task_done()
			try:
				self.sock.settimeout(1.0)
				data = self.sock.recv(40960)
				self.handle_data(data)
			except socket.timeout as sockerr:
				pass
				#print 'commandloop timeout reading from server !!!!!!!'
			except socket.error as sockerr:
				logging.warning('commandloop read error'+str(sockerr))
				self.reconnect()
		logging.info('commandloop finished, thread finished')

	def send_command(self,data):
#		print 'send_command, put',data,'on queue'
		self.queue.put(data)
#		print 'send_command, return' 
	
	def __init__(self, lms_type, line_handler, need_ssh_handler):
		self.line_handler = line_handler
		self.need_ssh_handler = need_ssh_handler
		self.lms_type = lms_type
		if (self.lms_type == 'command'):
			self.queue = Queue.Queue()
		threading.Thread.__init__ (self)
		self.daemon = True
	
	def run(self):
		self.reconnect()
		if (self.lms_type == 'listen'):
			self.listenloop()
		elif (self.lms_type == 'command'):
			self.commandloop()
		else:
			logging.error('unknown lms_type'+str(self.lms_type))

class searchcache():
	data = {} # a dictionary with the search identifier as key and lists as rows
	# the list of each row is in the form [label, track_id, album_id, artist_id, folder_id] 
	
	#def __init__(self):
	#	self.data = {}
	
	#the searchidentifier is in the form
	# artist,a
	# song,b
	# album,c
	# folder,d --> this one is not stored!!!!!!!!!!! this is handled special
	# folder,folder_id:0 --> the special case for all root folders
	# folder,folder_id:4
	# song,album_id:1
	# song,artist_id:2
	# album,artist_id:3
	
	def add(self,searchidentifier,treestore):
		logging.info('add '+searchidentifier+' to cache')
		results = []
		for row in treestore:
			results.append([str(row[0]), row[1], row[2], row[3], row[4]])
		self.data[searchidentifier] = results

	def add_folder_direct(self, label, folder_id):
		prefix = label[0].lower()
		ident = 'folder,folder_id:0,'+prefix
		logging.debug('add_folder_direct, ident='+ident)
		if (ident not in self.data):
			self.data[ident] = []
		self.data[ident].append([label, None, None, None, folder_id])

	def have_search(self, searchidentifier):
		logging.info('have_search, lookup '+searchidentifier+' result is '+str(searchidentifier in self.data))
		return (searchidentifier in self.data)
	
	def put_results(self, searchidentifier, treestore):
		logging.debug('add_results for ident='+searchidentifier)
		for row in self.data[searchidentifier]:
			treestore.append([row[0],row[1],row[2],row[3],row[4]])


class playlist():
	# a 	artist 
	# c 	coverid 
	# l 	album
	#u 	url 
	#y 	year
	#
	# 00%3A00%3Aba%3Abe%3A00%3A00 status 0 10 tags%3Aaly player_name%3Asq_marshall player_connected%3A1 player_ip%3A192.168.0.211%3A45802 power%3A1 signalstrength%3A0 mode%3Apause time%3A0 rate%3A1 duration%3A222.5 can_seek%3A1 mixer%20volume%3A94 playlist%20repeat%3A0 playlist%20shuffle%3A0 playlist%20mode%3Aoff seq_no%3A0 playlist_cur_index%3A14 playlist_timestamp%3A1446805187.12947 playlist_tracks%3A498 playlist%20index%3A0 id%3A14691 title%3AInfected artist%3AObituary album%3ACause%20of%20Death year%3A1990 playlist%20index%3A1 id%3A8083 title%3A15%3A36 artist%3AEdge%20of%20Sanity album%3AInfernal year%3A1997 playlist%20index%3A2 id%3A7013 title%3ASpirit%20Crusher artist%3ADeath album%3ALive%20In%20L.A.%20(Death%20%26%20Raw) year%3A2001 playlist%20index%3A3 id%3A14856 title%3A07.mp3 artist%3AOpeth album%3AStill%20life year%3A0 playlist%20index%3A4 id%3A8999 title%3AFear%20factory%20-%2008%20-%20Obsolete artist%3AFear%20Factory album%3AObsolete year%3A0 playlist%20index%3A5 id%3A9965 title%3AMonster%20Among%20Us. artist%3AGrip%20Inc. album%3APower%20of%20Inner%20Strength year%3A1995 playlist%20index%3A6 id%3A20934 title%3ASkip%20It artist%3AType%20O%20Negative album%3AWorld%20Coming%20Down year%3A1999 playlist%20index%3A7 id%3A22963 title%3AStench%20of%20Paradise%20Burning artist%3ADisincarnate album%3AAt%20Death's%20Door%20II year%3A1993 playlist%20index%3A8 id%3A15620 title%3APrimus%20-%20The%20Pressman.mp3 artist%3APrimus album%3APork%20soda year%3A0 playlist%20index%3A9 id%3A19291 title%3Ainnervision artist%3ASystem%20of%20a%20Down album%3ASteal%20This%20Album year%3A2002

	def __init__(self, builder):
		self.builder = builder
		self.plistwin = self.builder.get_object('playlistwindow')
		self.ploverlay = self.builder.get_object('ploverlay')
		plclosebut = self.builder.get_object('plbutclose')
		self.ploverlay.add_overlay(plclosebut)
		self.pltview = self.builder.get_object('pltview')
		self.reg1 = re.compile(config['player']+' status [0-9]+ [0-9]+ tags:aly')
		
	def clear(self):
		pls = self.builder.get_object('playliststore')
		pls.clear()

	def remove(self, number):
		#logging.debug('called with %d'%(number))
		pls = self.builder.get_object('playliststore')
		path = Gtk.TreePath([number])
		titer = pls.get_iter(path)
		if (titer):
			logging.debug('remove %d:%s'%(number, pls[number][0]))
			pls.remove(titer)

	def set_curindex(self, curindex):
		logging.debug('called with curindex %d'%(curindex))
		pls = self.builder.get_object('playliststore')
		for it,vals in enumerate(pls):
			if (vals[1]==700):
				pls[it][1] = 400
				#logging.debug('set normal '+str(it)+' '+vals[0])
			if (it==curindex):
				pls[it][1] = 700
				#logging.debug('set bold '+str(it)+' '+vals[0])
		plistwin = self.builder.get_object('playlistwindow')
		if (plistwin.is_visible()):
			# scroll
			path = Gtk.TreePath([curindex])
			select = self.pltview.get_selection()
			select.select_path(path)
			self.pltview.scroll_to_cell(path, None, True, 0.5, 0.5)
			
		
	def parse_status(self, curindex, line):
		foundcurindex = False
		reg = re.compile('playlist index:([0-9]+) id:([0-9]+) title:(.*?) artist:(.*?) album:(.*?) year:([0-9]+)')
		pls = self.builder.get_object('playliststore')
		for match in reg.finditer(line):
			index = int(match.group(1))
			weight=400
			if (curindex==index):
				foundcurindex = True
				weight=700
			#logging.debug('append index'+str(index)+', before append len='+str(len(self.data)))
			title = GLib.markup_escape_text(match.group(3))
			artist = GLib.markup_escape_text(match.group(4))
			album = GLib.markup_escape_text(match.group(5))
			year = GLib.markup_escape_text(match.group(6))
			tmp = title+'\n<span size="xx-small">'+album
			if (year and year!='0'):
				tmp += ' ('+year+')'
			tmp += ' - '+artist+'</span>'
			pls.append([tmp, weight])
			#if (curindex == index):
			#	logging.info('playlist appended curindex=%d, len=%d'%(curindex,len(pls)))
		if (foundcurindex):
			# scroll to the playing song and select
			path = Gtk.TreePath([curindex])
			select = self.pltview.get_selection()
			select.select_path(path)
			self.pltview.scroll_to_cell(path, None, True, 0.5, 0.5)

class vkeyboard():
	
	def kbactivate(self, widget):
		print 'kbactivate'
		kbwin = self.builder.get_object('kbwindow')
		text = self.kbentry.get_text()
		print 'got text'+text
		self.targetentry.set_text(text)
		kbwin.hide()
	
	def kbclick(self, widget):
		print 'kbclick', widget.get_label()
		tmp = widget.get_label()
		text = self.kbentry.get_text()
		if (tmp=='<'):
			text = text[:-1]
		elif (tmp == 'space'):
			text += ' '
		else:
			text += tmp
		self.kbentry.set_text(text)
	
	def __init__(self, builder):
		self.builder = builder
		#handlers = {
		#	"kbclick": self.kbclick,
		#	"kbactivate": self.kbactivate
		#}
		#self.builder.connect_signals(handlers)
		self.kbentry = self.builder.get_object('kbentry')
		
	
	def open_for_entry(self,entry):
		self.targetentry = entry
		kbwin = self.builder.get_object('kbwindow')
		kbwin.show_all()
		

class sqgui2():
	initfirst_done = False
	sockcommand = False
	updateTimeLock = 0
	updateVolumeLock = 0
	need_ssh = False
	procsqueezelite = False
	procssh = False
	procssh2 = False
	coverimgdata = False
	overlayimage = False
	searchprefix = 'a'
	searchbatchsize = 100
	longpress_time = 600
	searchtreeview_kinetic_scroll_interval = 50
	searchtreeview_kinetic_scroll_factor = 2
	searchtreeview_kinetic_prevspeed = 0
	pltview_kinetic_scroll_interval = 50
	pltview_kinetic_scroll_factor = 2
	pltview_kinetic_prevspeed = 0
	pltview_longpress_srcid = None
	pltview_press_started = False
	pltview_kineticscroll_srcid = None

	search_have_ids = []
	songinfo_longpress_srcid = None
	searchtreeview_longpress_srcid = None
	searchtreeview_press_started = False
	searchtreeview_kineticscroll_srcid = None

	def update_time(self):
		timeAdj = self.builder.get_object('timeAdj')
		self.updateTimeLock = 1
		timeAdj.set_value(self.status.songtime)
		self.updateTimeLock = 0
		durlabel = self.builder.get_object('timeLabel')
		durlabel.set_text(self.status.formatted_songtime())
	
	def updatemode(self):
		image = self.builder.get_object('butPlayImage')
		if(self.status.mode == 'play'):
			image.set_from_file('pause.png');
		else:
			image.set_from_file('play.png');
	
	def updateshuffle(self):
		mi = self.builder.get_object('shufflemenuitem')
		if (self.status.shuffle != mi.get_active()):
			mi.set_active(self.status.shuffle)

	def updaterepeat(self):
		mi = self.builder.get_object('repeatmenuitem')
		if (self.status.repeat != mi.get_active()):
			logging.info('set repeat menu-item to '+str(self.status.repeat))
			mi.set_active(self.status.repeat)
		
	
	def updatelabel(self):
		label = self.builder.get_object('tlabel')
		label.set_markup('<big><b>'+GLib.markup_escape_text(self.status.song)+'</b></big>')
		label = self.builder.get_object('aalabel')
		label.set_markup(GLib.markup_escape_text(self.status.artist)+'\n'+GLib.markup_escape_text(self.status.album))
		timeAdj = self.builder.get_object('timeAdj')
		if (self.status.duration > 0.1):
			timeAdj.set_upper(self.status.duration);
			durlabel = self.builder.get_object('durationLabel')
			durlabel.set_text(self.status.formatted_duration())
	
	def parse_titles_results(self, searchstring, line, finished):
		#print 'parse_titles_results, got line',line
		reg = re.compile('id:([0-9]+) title:(.*?) artist:(.*?) album:(.*?) samplerate:[0-9]+')
		srs = self.builder.get_object('searchresultstore')
		for match in reg.finditer(line):
			curid = int(match.group(1))
			if ((self.searchprefix==None or match.group(2)[0].lower() == self.searchprefix) and (curid not in self.search_have_ids)):
				self.search_have_ids.append(curid)
				tmp = GLib.markup_escape_text(match.group(2))+'\n<span size="xx-small">'+GLib.markup_escape_text(match.group(3))+' - '+GLib.markup_escape_text(match.group(4))+'</span>'
				srs.append([tmp,curid,None,None,None])
		if (finished):
			self.cache.add(searchstring, srs)

	def parse_albums_results(self, searchstring, line, finished):
		# created for queries like 'albums 0 5 search:best tags:als' where the s is there to make the regex capture the full artist name
		#print 'parse_albums_results, got line',line
		reg = re.compile('id:([0-9]+) album:(.*?) artist:(.*?) textkey:[0-9a-zA-Z]+')
		srs = self.builder.get_object('searchresultstore')
		for match in reg.finditer(line):
			curid = int(match.group(1))
			logging.debug('%s %s %s'%(match.group(1),match.group(2),match.group(3)))
			if ((self.searchprefix==None or match.group(2)[0].lower() == self.searchprefix) and (curid not in self.search_have_ids)):
				self.search_have_ids.append(curid)
				tmp = GLib.markup_escape_text(match.group(2))+'\n<span size="xx-small">'+GLib.markup_escape_text(match.group(3))+'</span>'
				srs.append([tmp,None,int(match.group(1)),None,None])
		if (finished):
			self.cache.add(searchstring, srs)
		
	def parse_artists_results(self, searchstring, line, finished):
		#print 'parse_artists_results, got line',line
		reg = re.compile('id:([0-9]+) artist:(.*?) textkey:[0-9a-zA-Z]+')
		srs = self.builder.get_object('searchresultstore')
		for match in reg.finditer(line):
			curid = int(match.group(1))
			if ((self.searchprefix==None or match.group(2)[0].lower() == self.searchprefix) and (curid not in self.search_have_ids)):
				self.search_have_ids.append(curid)
				srs.append([GLib.markup_escape_text(match.group(2)),None,None,int(match.group(1)),None])
		if (finished):
			self.cache.add(searchstring, srs)
	
	def parse_musicfolder_results(self, searchstring, line, finished):
		reg = re.compile('id:([0-9]+) filename:(.*?) type:([0-9a-zA-Z]+)')
		srs = self.builder.get_object('searchresultstore')
		process_root = (searchstring == 'folder,folder_id:0')
		logging.debug('got '+line)
		for match in reg.finditer(line):
			curid = int(match.group(1))
			#print 'found folder_id=',curid,'with name',match.group(2),'and type',match.group(3)
			#print 'searchprefix',self.searchprefix
			#print 'comparing',match.group(2)[0].lower(),self.searchprefix
			#print 'first test ',(self.searchprefix==None or match.group(2)[0].lower() == self.searchprefix)
			#print 'second test',(curid not in self.search_have_ids),'len=',len(self.search_have_ids)
			if ((self.searchprefix==None or match.group(2)[0].lower() == self.searchprefix) and (curid not in self.search_have_ids)):
				self.search_have_ids.append(curid)
				if (match.group(3) == 'folder'):
					#print 'append to treestore as folder'
					srs.append([GLib.markup_escape_text(match.group(2)),None,None,None,int(match.group(1))])
				else:
					#print 'append as mp3'
					srs.append([GLib.markup_escape_text(match.group(2)),int(match.group(1)),None,None,None])
			if (process_root):
				self.cache.add_folder_direct(match.group(2), int(match.group(1)))
		if (finished and not process_root):
			self.cache.add(searchstring, srs)
		
	def init_regex(self):
		# 00:00:00:00:ba:be playlist newsong Solid state 18
		self.reg1  = re.compile(config['player']+' playlist newsong (.*) ([0-9]+)')
		self.reg2  = re.compile(config['player']+' time (.*)')
		self.reg3  = re.compile(config['player']+' playlist (stop|pause 1|pause 0)')
		self.reg4  = re.compile(config['player']+' mixer volume ([0-9.]+)')
		self.reg5  = re.compile(config['player']+' path (.*)')
		self.reg5a = re.compile(config['player']+' playlist open (.*)')
		# 00:00:00:00:ba:be songinfo 0 20 url:file:///home2/public/muziek/Obituary/Dead/16 Slowly We Rot (5m 06s).mp3 tags:aelsd id:15344 title:Slowly We Rot artist:Obituary album_id:1582 album:Dead artist_id:1974 duration:306.335 coverid:b59fcc90
		# 00:00:00:00:ba:be songinfo 0 20 url:file:///home2/public/muziek/Obituary/Dead/16 Slowly We Rot (5m 06s).mp3 tags:aelsd id:15344 title:Slowly We Rot artist:Obituary album_id:1582 album:Dead artist_id:1974 duration:306.335
		# 00:00:00:ba:be:00 songinfo 0 20 url:file:///home2/public/muziek/Dave%20Brubeck/Dave%20Brubeck%20-%20The%20Very%20Best%20Of%20(2000)/Dave%20Brubeck%20-%20The%20Very%20Vest%20-%2001%20-%20Unsquare%20Dance.mp3 tags:aelsdc rescan:1 id:6601 title:Unsquare Dance artist:Dave Brubeck album_id:689 album:The Very Best artist_id:1651 duration:120.693 coverid:b88bd70b
		self.reg5b = re.compile(config['player']+' songinfo [0-9]+ [0-9]+ url:.*? tags:aelsdc( rescan:1)? id:([0-9]+) title:(.*?) artist:(.*?) album_id:([0-9]+) album:(.*?) artist_id:([0-9]+) duration:([0-9.]+)( coverid:[a-z0-9A-Z]+)?')
		self.reg6a = re.compile(config['player']+' (artist|album|title) (.*)')
		self.reg7  = re.compile(config['player']+' duration (.*)')
		self.reg8  = re.compile(config['player']+' mode (.*)')
		self.reg9  = re.compile(config['player']+' playlist (shuffle|repeat) (0|1|2)')
		self.reg10 = re.compile(config['player']+' client (disconnect|reconnect)')
		self.reg11 = re.compile(config['player']+' titles ([0-9]+) ([0-9]+) (search|artist_id|album_id):(.*?) tags:[a-zA-Z]+ (.*) count:([0-9]+)')
		self.reg12 = re.compile(config['player']+' artists ([0-9]+) ([0-9]+) search:(.*?) tags:[a-zA-Z]+ (.*) count:([0-9]+)')
		self.reg13 = re.compile(config['player']+' albums ([0-9]+) ([0-9]+) (search|artist_id):(.*?) tags:[a-zA-Z]+ (.*) count:([0-9]+)')
		self.reg14 = re.compile(config['player']+' musicfolder ([0-9]+) ([0-9]+) (folder_id:[0-9]+) (.*) count:([0-9]+)')
		# 00%3A00%3Aba%3Abe%3A00%3A00 status 0 10 tags%3Aaly player_name%3Asq_marshall player_connected%3A1 player_ip%3A192.168.0.211%3A45802 power%3A1 signalstrength%3A0 mode%3Apause time%3A0 rate%3A1 duration%3A222.5 can_seek%3A1 mixer%20volume%3A94 playlist%20repeat%3A0 playlist%20shuffle%3A0 playlist%20mode%3Aoff seq_no%3A0 playlist_cur_index%3A14 playlist_timestamp%3A1446805187.12947 playlist_tracks%3A498 playlist%20index%3A0 id%3A14691 title%3AInfected artist%3AObituary album%3ACause%20of%20Death year%3A1990 
		self.reg15 = re.compile(config['player']+' status ([0-9]+) ([0-9]+) tags:aly .*? playlist_cur_index:([0-9]+) .*? playlist_tracks:([0-9]+) (.*)')
		self.reg16 = re.compile(config['player']+' playlist delete ([0-9]+)')
		self.reg17 = re.compile(config['player']+' playlist (loadtracks .*|load_done)')
 	
	def line_handler(self,data):
		lms_type,line = data
		logging.debug(' type:%s got line "%s"'%(lms_type,line))
		res = self.reg1.match(line)
		if (res):
			logging.info('newsong, the moment that the new song actually starts')
			if (res.group(1) != self.status.song):
				if (res.group(1) != self.status.next_song):
					logging.info('newsong incicates "'+res.group(1)+'", nextsong is "'+self.status.next_song+'", request path')
					self.status.song = res.group(1)
					# request songinfo, but we need a track_id or url for that
					self.send_player_command('path ?')
				else:
					self.status.next2cur()
					self.artwork_thread.set_cover(self.status.coverid)
				self.updatelabel()
				self.status.reftime = time.time()
				self.songtime = 0.0
				self.update_time()
				self.send_player_command('time ?')
			if (self.status.mode != 'play'):
				self.status.mode = 'play'
				self.updatemode()
			self.plist.set_curindex(int(res.group(2)))
		res = self.reg2.match(line)
		if (res):
			logging.info('got time '+res.group(1))
			self.status.songtime = float(res.group(1))
			self.status.reftime = time.time() - self.status.songtime
			self.update_time()
		res = self.reg3.match(line)
		if (res):
			logging.info('pause/play, got '+res.group(1))
			if (res.group(1)=='pause 0'):
				self.status.mode = 'play'
				self.send_player_command('time ?')
			else:
				self.status.mode = 'pause'
			self.updatemode()
		#if (lms_type == 'listen'):
		res = self.reg4.match(line)
		if (res):
			self.updateVolumeLock = 1
			tmp = float(res.group(1))
			volumeAdj = self.builder.get_object('volumeAdj')
			volumeAdj.set_value(tmp)
			self.updateVolumeLock = 0
		res = self.reg5.match(line)
		if (res):
			#path
			if (res.group(1) != self.status.next_url and res.group(1) != '?'):
				logging.debug('got path, request songinfo for '+res.group(1))
				self.send_player_command('songinfo 0 20 url:'+urllib.quote(res.group(1))+' tags:aelsdc')
			else:
				logging.debug('got path, but path matches next_url '+self.status.next_url+', so ignoring it')
		if (lms_type == 'listen'):
			res = self.reg5a.match(line)
			if (res):
				# for some reason this is called twice, a few seconds before the song starts playing (when 'playlist newsong' is called) 
				# I saw an error where playlist open was called 500 times for every file on the playlist. 
				# we should not call a new one when there is still one running
				if (res.group(1) != self.status.next_url and self.status.nextrunning == 0):
					logging.info('got playlist open, request songinfo for url and call resetnext()')
					self.send_player_command('songinfo 0 20 url:'+urllib.quote(res.group(1))+' tags:aelsdc')
					self.status.resetnext(res.group(1))
				else:
					if (self.status.nextrunning):
						logging.debug('got playlist open, but nextrunning is TRUE')
					else:
						logging.debug('got playlist open, but have data for '+self.status.next_url+' already')
		res = self.reg5b.match(line)
		if (res):
			self.status.nextrunning = 0
			#songinfo [0-9]+ [0-9]+ url:.*? tags:aelsdc( rescan:1)? id:([0-9]+) title: (.*?) artist: (.*?) album_id:([0-9]+) album: (.*?) artist_id:([0-9]+) duration:([0-9.]+)( coverid:[a-z0-9A-Z]+)?
			self.status.next_track_id = res.group(2)
			self.status.next_song = res.group(3)
			self.status.next_artist = res.group(4)
			self.status.next_album_id = res.group(5)
			self.status.next_album = res.group(6)
			self.status.next_artist_id = res.group(7)
			self.status.next_duration = res.group(8)
			if (res.group(9)): # can be None if there was no coverid
				self.status.next_coverid = res.group(9).split(':')[1]
				self.artwork_thread.retrieve_next_cover(self.status.next_coverid) 
			if (self.status.song == self.status.next_song):
				logging.debug('got songinfo for currently playing song')
				self.status.next2cur()
				self.artwork_thread.set_cover(self.status.coverid)
				self.updatelabel()
			else:
				logging.debug('got songinfo for next song')
		res = self.reg6a.match(line)
		if (res):
			logging.debug('got (artist|album|title) --> '+res.group(1)+', change value for current song and call updatelabel()')
			if (res.group(1)=='title'):
				self.status.song = res.group(2)
			elif (res.group(1)=='album'):
				self.status.album = res.group(2)
			elif (res.group(1)=='artist'):
				self.status.artist = res.group(2)
			self.updatelabel()
		res = self.reg7.match(line)
		if (res):
			#print 'duration'
			self.status.set_duration(res.group(1))
			self.updatelabel()
		res = self.reg8.match(line)
		if (res):
			logging.debug('got mode '+res.group(1))
			self.status.mode = res.group(1)
			self.updatemode()
		res = self.reg9.match(line)
		if (res):
			if (res.group(1)=='shuffle'):
				self.status.shuffle = (res.group(2)!='0')
				self.updateshuffle()
			elif (res.group(1)=='repeat'):
				self.status.repeat = (res.group(2)!='0')
				self.updaterepeat()
		res = self.reg10.match(line)
		if (res):
			if (res.group(1) == 'disconnect'):
				self.status.mode = 'pause'
				self.updatemode()
				label = self.builder.get_object('tlabel')
				label.set_markup('<span foreground="red" size="x-large" weight="bold">Disconnected</span>')
			if (res.group(1) == 'reconnect'):
				self.updatelabel()
		res = self.reg11.match(line)
		# config['player']+' titles ([0-9]+) ([0-9]+) (search|artist_id|album_id):([^ ]+) tags:[a-zA-Z]+ (.*) count:([0-9]+)'
		if (res):
			count = int(res.group(6))
			nextstart = int(res.group(1))+self.searchbatchsize
			if (count > nextstart):
				self.send_player_command('titles '+str(nextstart)+' '+str(self.searchbatchsize)+' '+res.group(3)+':'+urllib.quote(res.group(4))+' tags:alT')
				finished = False
			else:
				finished = True
			self.parse_titles_results('song,'+res.group(3)+':'+urllib.quote(res.group(4)), res.group(5), finished)
		res = self.reg12.match(line)
		# config['player']+' artists ([0-9]+) ([0-9]+) search:([^ ]+) tags:[a-zA-Z]+ (.*) count:([0-9]+)'
		if (res):
			count = int(res.group(5))
			nextstart = int(res.group(1))+self.searchbatchsize
			if (count > nextstart):
				self.send_player_command('artists '+str(nextstart)+' '+str(self.searchbatchsize)+' search:'+urllib.quote(res.group(3))+' tags:s')			
				finished = False
			else:
				finished = True
			self.parse_artists_results('artist,search:'+res.group(3), res.group(4), finished)
		res = self.reg13.match(line)
		# config['player']+' albums ([0-9]+) ([0-9]+) (search|artist_id):([^ ]+) tags:[a-zA-Z]+ (.*) count:([0-9]+)'
		if (res):
			count = int(res.group(6))
			nextstart = int(res.group(1))+self.searchbatchsize
			if (count > nextstart):
				self.send_player_command('albums '+str(nextstart)+' '+str(self.searchbatchsize)+' '+res.group(3)+':'+urllib.quote(res.group(4))+' tags:als')						
				finished = False
			else:
				finished = True
			self.parse_albums_results('album,'+res.group(3)+':'+res.group(4), res.group(5), finished)
		res = self.reg14.match(line)
		if (res):
			# config['player']+' musicfolder ([0-9]+) ([0-9]+) (folder_id:[0-9]+) (.*) count:([0-9]+)'
			# 00:00:00:ba:be:00 musicfolder 0 100 folder_id:0 rescan:1 count:1 filename:Music Folder is not available while scanning. type:text
			if (res.group(4)=='rescan:1'):
				# abort rescan and request folder again
				self.commandthread.send_command('abortscan\n')
				self.send_player_command('musicfolder 0 '+str(self.searchbatchsize)+' '+res.group(3))
			else:
				count = int(res.group(5))
				nextstart = int(res.group(1))+self.searchbatchsize
				if (count > nextstart):
					self.send_player_command('musicfolder '+str(nextstart)+' '+str(self.searchbatchsize)+' '+res.group(3))
					finished = False
				else:
					finished = True
				self.parse_musicfolder_results('folder,'+res.group(3), res.group(4), finished)
		res = self.reg15.match(line)
		if (res):
			# config['player']+' status ([0-9]+) ([0-9]+) tags:aly .*? playlist_cur_index:([0-9]+) .*? playlist_tracks:([0-9]+) (.*)'
			cur_index = int(res.group(3))
			count = int(res.group(4))
			nextstart = int(res.group(1))+self.searchbatchsize
			if (count > nextstart):
				self.send_player_command('status '+str(nextstart)+' '+str(self.searchbatchsize)+' tags:aly')
			self.plist.parse_status(cur_index, res.group(5))
		if (lms_type == 'listen'):
			res = self.reg16.match(line)
			if (res):
			# remove res.group(1) from the playlist
				self.plist.remove(int(res.group(1)))
		res = self.reg17.match(line)
		if (res):
			logging.debug('playlist load, clear playlistwindow and request status')
			self.plist.clear()
			plistwin = self.builder.get_object('playlistwindow')
			if (plistwin.is_visible()):
				# only send if playlist is visible
				self.send_player_command('status 0 '+str(self.searchbatchsize)+' tags:aly')
		return 0

	def start_procsqueezelite(self):
		try:
			logging.debug('starting squeezelite...')
			self.procsqueezelite = subprocess.Popen([config['squeezelite'], '-s', config['server_ip'], '-m', config['player'], '-n', config['playername']])
			logging.debug(config['squeezelite']+' running at '+str(self.procsqueezelite.pid))
		except OSError as err:
			logging.warning('error starting'+config['squeezelite']+':'+str(err))		

	def start_ssh(self):
		if (self.need_ssh):
			try:
				self.procssh = subprocess.Popen(['/usr/bin/ssh', 'squeezeserver_data', '-N'])
				logging.info('ssh_data running at '+str(self.procssh.pid))
			except OSError as err:
				logging.warning('error starting ssh_data: '+str(err))		

	def start_ssh2(self):
		if (self.need_ssh):
			try:
				self.procssh2 = subprocess.Popen(['/usr/bin/ssh', 'squeezeserver_lowl', '-N'])
				logging.info('ssh_lowl running at '+str(self.procssh2.pid))
			except OSError as err:
				logging.warning('error starting ssh_lowl:'+str(err))		


	def check_processes(self):
		#print 'check_processes, procsqueezelite at pid ',self.procsqueezelite.pid
		if (self.procsqueezelite):
			ret = self.procsqueezelite.poll()
			#print 'checking got ',ret
		else:
			ret = 255
		if (ret != None):
			logging.warning('check_processes(), (re)start squeezelite, ret='+str(ret))
			self.start_procsqueezelite()
		if (self.need_ssh):
			if (self.procssh):
				ret = self.procssh.poll()
				#print 'checking got ',ret
			else:
				logging.debug('procssh not yet running')
				ret = 255
			if (ret != None):
				logging.debug('check_processes(), (re)start ssh, ret='+str(ret))
				self.start_ssh()
			if (self.procssh2):
				ret = self.procssh2.poll()
				#print 'checking got ',ret
			else:
				logging.debug('procssh2 not yet running')
				ret = 255
			if (ret != None):
				logging.debug('check_processes(), (re)start ssh2, ret='+str(ret))
				self.start_ssh2()

	
	def second_callback(self,data):
		if (self.status.mode == 'play'):
			self.status.update_songtime()
			self.update_time()
		self.check_processes()
		return 1
	
	def need_ssh_handler(self):
		if ('nossh' in config and config['nossh']):
			return False
		if (not self.need_ssh):
			logging.warning('set need_ssh to true')
			self.need_ssh = True
			config['server_ip'] = '127.0.0.1'
			if (self.procsqueezelite):
				self.procsqueezelite.kill()
			self.check_processes()
	
	def artwork_handler(self,imgdata):
		#print 'artwork_handler, got ',len(imgdata),'bytes of imgdata'
		self.coverimgdata = imgdata
		image = self.builder.get_object('coverimage')
		largeimage = self.builder.get_object('largecoverimage')
		pbl = GdkPixbuf.PixbufLoader()
		pbl.set_size(120,120)
		pbl2 = GdkPixbuf.PixbufLoader()
		pbl2.set_size(240,240)
		try:
			pbl.write(imgdata)
			image.set_from_pixbuf(pbl.get_pixbuf())
			pbl2.write(imgdata)
			largeimage.set_from_pixbuf(pbl2.get_pixbuf())
		except:
			logging.warning('artwork_handler, failed to parse image data')
		try:
			pbl.close()
		except:
			pass
		try:
			pbl2.close()
		except:
			pass
		return 0
	
	def get_ip_address(self,ifname):
		s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
		try:
			return socket.inet_ntoa(fcntl.ioctl(
				s.fileno(),
				0x8915,  # SIOCGIFADDR
				struct.pack('256s', ifname[:15])
				)[20:24])
		except:
			return ''

	def on_local_network(self):
		eth0_ip = ''
		wlan0_ip = ''
		eth0_ip = self.get_ip_address('eth0')
		wlan0_ip = self.get_ip_address('wlan0')
		if (eth0_ip=='' and wlan0_ip==''):
			return -1
		if (eth0_ip in ('192.168.0.197', '192.168.0.211', '192.168.0.196') or wlan0_ip in ('192.168.0.197', '192.168.0.189', '192.168.0.187')):
			return 1
		return 0
	
	def init_with_network(self):
		self.check_processes()
		self.listenthread = lms_thread('listen',self.line_handler,self.need_ssh_handler)
		self.listenthread.start()
		self.commandthread = lms_thread('command',self.line_handler,self.need_ssh_handler)
		self.commandthread.start()
		self.artwork_thread = artwork_thread(self.artwork_handler)
		self.artwork_thread.start()
		self.send_player_command('mixer volume ?')
		self.send_player_command('mode ?')
		#self.send_player_command('duration ?')
		self.send_player_command('title ?')
		#self.send_player_command('album ?')
		#self.send_player_command('artist ?')
		self.send_player_command('path ?')
		self.send_player_command('playlist shuffle ?')
		self.send_player_command('playlist repeat ?')
	
	def init_first(self):
		if (self.initfirst_done):
			return

		try:
			subprocess.call(['/usr/bin/xset','s', 'off'])
			subprocess.call(['/usr/bin/xset', 's', 'noblank'])
			subprocess.call(['/usr/bin/xset',  '-dpms'])
		except OSError,e:
			logging.warning('/usr/bin/xset failed to execute')

		self.init_regex()
		self.cache = searchcache()
		self.plist = playlist(self.builder)
		self.initfirst_done = True
	
	def init_idle(self,userdata):
		logging.debug('init_idle()')
		self.init_first()
		if ('localhost' in config and config['localhost']):
			ret = 1
		else:
			ret = self.on_local_network()
		if (ret==-1):
			time.sleep(0.5)
			return True
		if (ret == 0):
			self.need_ssh_handler()
		self.init_with_network()
		GLib.timeout_add_seconds(1,self.second_callback,0);
		return False

	def send_player_command(self,command):
		logging.info('send_player_command '+command)
		self.commandthread.send_command(config['player']+' '+command+'\n')

	def closeClicked(self,but):
		subprocess.call(["sudo", "shutdown", "-h", "now"])

	def songinfo_longpress_event(self,widget):
		logging.debug('songinfo_longpress_event')
		popup = self.builder.get_object('mainwinmenu')
		popup.popup(None, None, None, None, 1, Gtk.get_current_event_time())
		GLib.source_remove(self.songinfo_longpress_srcid)
		self.songinfo_longpress_srcid = None
		return False

	def songinfo_button_press_event(self,widget,event):
		if (self.songinfo_longpress_srcid):
			GLib.source_remove(self.songinfo_longpress_srcid)
		self.songinfo_longpress_srcid = GLib.timeout_add(self.longpress_time, self.songinfo_longpress_event, widget)

	def songinfo_button_release_event(self,widget,event):
		if (self.songinfo_longpress_srcid):
			GLib.source_remove(self.songinfo_longpress_srcid)
			self.songinfo_longpress_srcid = None

	def mi_mw_al_ar_activate_cb(self,widget):
		self.builder.get_object('searchwindow').show_all()
		self.new_search('album', 'artist_id:'+str(self.status.artist_id), 'Albums by '+self.status.artist)

	def mi_mw_so_ar_activate_cb(self,widget):
		self.builder.get_object('searchwindow').show_all()
		self.new_search('song', 'artist_id:'+str(self.status.artist_id), 'Songs by '+self.status.artist)

	def mi_mw_so_al_activate_cb(self,widget):
		self.builder.get_object('searchwindow').show_all()
		self.new_search('song', 'album_id:'+str(self.status.album_id), 'Songs on '+self.status.album)

	def mi_pl_play_activate_cb(self,widget):
		pltview = self.builder.get_object('pltview')
		select = pltview.get_selection()
		model,titer = select.get_selected()
		if (model and titer):
			path = model.get_path(titer)
			newindex = int(str(path))
			logging.info('playlist switch to newindex %d'%(newindex))
			self.send_player_command('playlist index '+str(newindex))
	
	def mi_pl_delete_activate_cb(self,widget):
		pltview = self.builder.get_object('pltview')
		select = pltview.get_selection()
		model,titer = select.get_selected()
		if (model and titer):
			path = model.get_path(titer)
			index = int(str(path))
			logging.info('playlist delete index %d'%(index))
			self.send_player_command('playlist delete '+str(index))


	def pltview_cancel_all(self):
 		if (self.pltview_press_started):
 			self.pltview_press_started = False
 		if (self.pltview_longpress_srcid):
			GLib.source_remove(self.pltview_longpress_srcid)
			self.pltview_longpress_srcid = None
		if (self.pltview_kineticscroll_srcid):
			GLib.source_remove(self.pltview_kineticscroll_srcid)
			self.pltview_kineticscroll_srcid = None


	def pltview_longpress_event(self,widget):
		logging.debug('pltview_longpress_event')
		
		popup = self.builder.get_object('playlistmenu')
		#searchtreeview = self.builder.get_object('searchtreeview')
		#select = searchtreeview.get_selection()
		#model,titer = select.get_selected()
		popup.popup(None, None, None, None, 1, Gtk.get_current_event_time())
		if (self.pltview_longpress_srcid):
			GLib.source_remove(self.pltview_longpress_srcid)
		self.pltview_longpress_srcid = None
		return False

	def pltview_button_press_event_cb(self,widget,event):
		logging.debug('pltview_button_press_event')
		if (self.pltview_kineticscroll_srcid):
			GLib.source_remove(self.pltview_kineticscroll_srcid)
			self.pltview_kineticscroll_srcid = None
		if (self.pltview_longpress_srcid):
			GLib.source_remove(self.pltview_longpress_srcid)
		self.pltview_press_started = True
		self.pltview_longpress_srcid = GLib.timeout_add(self.longpress_time, self.pltview_longpress_event, widget)
		self.pltview_pressloc = (event.x,event.y)
		self.pltview_presstime = event.time
		va = self.builder.get_object('plvscrolladjustment')
		self.pltview_press_adval = va.get_value()
		return False

	def pltview_kineticscroll(self,widget):
		va = self.builder.get_object('plvscrolladjustment')
		newval = va.get_value() + self.pltviewspeed * (1000 / self.pltview_kinetic_scroll_interval) * self.pltview_kinetic_scroll_factor
		if (newval > 0 and newval < va.get_upper()):
			va.set_value(newval)
		else:
			if (self.pltview_kineticscroll_srcid):
				GLib.source_remove(self.pltview_kineticscroll_srcid)
			self.pltview_kineticscroll_srcid = None
			return False
		return True

	def pltview_button_release_event_cb(self,widget,event):
		logging.debug('pltview_button_release_event')
		self.pltview_press_started = False
		if (self.pltview_longpress_srcid):
			GLib.source_remove(self.pltview_longpress_srcid)
			self.pltview_longpress_srcid = None
		delta = self.pltview_pressloc[1] - event.y
		if (abs(delta) > 10):
			# calculate the speed of the gesture
			timedelta = event.time - self.pltview_presstime
			self.pltviewspeed = (delta/timedelta + self.pltview_kinetic_prevspeed)/2
			logging.debug('timedelta='+str(timedelta)+' realspeed='+str(delta/timedelta)+' usespeed='+str(self.pltviewspeed))
			self.pltview_kineticscroll_srcid = GLib.timeout_add(self.pltview_kinetic_scroll_interval, self.pltview_kineticscroll, widget)
			self.pltview_kinetic_prevspeed = 0
		return False
	
	def pltview_motion_notify_event_cb(self,widget,event):
		#logging.debug('pltview_motion_notify_event')
		if (self.pltview_press_started):
			delta = self.pltview_pressloc[1] - event.y
			if (abs(delta) > 10):
				# start scrolling and disable longpress
				if (self.pltview_longpress_srcid):
					GLib.source_remove(self.pltview_longpress_srcid)
					self.pltview_longpress_srcid = None
				va = self.builder.get_object('plvscrolladjustment')
				if (self.pltview_kinetic_prevspeed == 0):
					self.pltview_kinetic_prevspeed = delta/(event.time - self.pltview_presstime)
				else:
					self.pltview_kinetic_prevspeed = (self.pltview_kinetic_prevspeed + delta/(event.time - self.pltview_presstime))/2
				newval = self.pltview_press_adval + delta * self.pltview_kinetic_scroll_factor
				#logging.debug('change adjustment value to '+str(newval)+'speed='+str((delta/(event.time - self.pltview_presstime))))
				if (newval > 0 and newval < va.get_upper()):
					va.set_value(newval)
		return False
 
 	def pltview_leave_notify_event(self,widget,event):
 		#logging.debug('pltview_leave_notify_event')
 		self.pltview_cancel_all()

	def playlistwindow_delete_event_cb(self,widget,event):
		self.pltview_cancel_all()
		widget.hide()
		return True

	def plcloseclicked(self,but):
		plwin = self.builder.get_object('playlistwindow')
		plwin.hide()

	def searchcloseclicked(self,but):
		searchwin = self.builder.get_object('searchwindow')
		searchwin.hide()

	def searchclicked(self,but):
		spcombo = self.builder.get_object('searchprefixcombo')
		self.searchprefixchanged(spcombo)
		searchwin = self.builder.get_object('searchwindow')
		searchwin.show_all()

	def searchtreeview_cancel_all(self):
 		if (self.searchtreeview_press_started):
 			self.searchtreeview_press_started = False
 		if (self.searchtreeview_longpress_srcid):
			GLib.source_remove(self.searchtreeview_longpress_srcid)
			self.searchtreeview_longpress_srcid = None
		if (self.searchtreeview_kineticscroll_srcid):
			GLib.source_remove(self.searchtreeview_kineticscroll_srcid)
			self.searchtreeview_kineticscroll_srcid = None

	
	def searchwindow_delete_event_cb(self,widget,event):
		self.searchtreeview_cancel_all()
		widget.hide()
		return True
	
	def kbwindow_delete_event_cb(self,widget,event):
		self.searchtreeview_cancel_all()
		widget.hide()
		return True		
	
	def searchtreeviewactivated(self,treeview,path,column):
		logging.debug("searchtreeviewactivated path="+str(path))
		# now popup a menu if you want to append to playlist, replace playlist, or search this artist for songs, this artist for albums/this album for songs
		
	def searchtreeview_longpress_event(self,widget):
		logging.debug('searchtreeview_longpress_event')
		
		popup = self.builder.get_object('searchresultmenu')
		searchtreeview = self.builder.get_object('searchtreeview')
		select = searchtreeview.get_selection()
		model,titer = select.get_selected()
		# 1=track_id, 2=album_id, 3=artist_id, 4=folder_id
		#print 'popup menu, currently selected 3/4/5/6:',model[titer][3],model[titer][4],model[titer][5],model[titer][6]
		if (model and titer):
			self.builder.get_object('mi_br_album').set_visible(model[titer][3])
			self.builder.get_object('mi_so_artist').set_visible(model[titer][3])
			self.builder.get_object('mi_br_so_album').set_visible(model[titer][2])
			self.builder.get_object('mi_browse_folder').set_visible(model[titer][4])
		popup.popup(None, None, None, None, 1, Gtk.get_current_event_time())
		if (self.searchtreeview_longpress_srcid):
			GLib.source_remove(self.searchtreeview_longpress_srcid)
		self.searchtreeview_longpress_srcid = None
		return False

	def searchtreeview_button_press_event(self,widget,event):
		if (self.searchtreeview_kineticscroll_srcid):
			GLib.source_remove(self.searchtreeview_kineticscroll_srcid)
			self.searchtreeview_kineticscroll_srcid = None
		if (self.searchtreeview_longpress_srcid):
			GLib.source_remove(self.searchtreeview_longpress_srcid)
		self.searchtreeview_press_started = True
		self.searchtreeview_longpress_srcid = GLib.timeout_add(self.longpress_time, self.searchtreeview_longpress_event, widget)
		self.searchtreeview_pressloc = (event.x,event.y)
		self.searchtreeview_presstime = event.time
		va = self.builder.get_object('vscrolladjustment')
		self.searchtreeview_press_adval = va.get_value()
		return False

	def searchtreeview_kineticscroll(self,widget):
		va = self.builder.get_object('vscrolladjustment')
		newval = va.get_value() + self.searchtreeviewspeed * (1000 / self.searchtreeview_kinetic_scroll_interval) * self.searchtreeview_kinetic_scroll_factor
		if (newval > 0 and newval < va.get_upper()):
			va.set_value(newval)
		else:
			if (self.searchtreeview_kineticscroll_srcid):
				GLib.source_remove(self.searchtreeview_kineticscroll_srcid)
			self.searchtreeview_kineticscroll_srcid = None
			return False
		return True

	def searchtreeview_button_release_event(self,widget,event):
		self.searchtreeview_press_started = False
		if (self.searchtreeview_longpress_srcid):
			GLib.source_remove(self.searchtreeview_longpress_srcid)
			self.searchtreeview_longpress_srcid = None
		delta = self.searchtreeview_pressloc[1] - event.y
		if (abs(delta) > 10):
			# calculate the speed of the gesture
			timedelta = event.time - self.searchtreeview_presstime
			self.searchtreeviewspeed = (delta/timedelta + self.searchtreeview_kinetic_prevspeed)/2
			logging.debug('timedelta='+str(timedelta)+' realspeed='+str(delta/timedelta)+' usespeed='+str(self.searchtreeviewspeed))
			self.searchtreeview_kineticscroll_srcid = GLib.timeout_add(self.searchtreeview_kinetic_scroll_interval, self.searchtreeview_kineticscroll, widget)
			self.searchtreeview_kinetic_prevspeed = 0
		return False
	
	def searchtreeview_motion_notify_event(self,widget,event):
		if (self.searchtreeview_press_started):
			#print 'searchtreeview_motion_notify_event',event.x,event.y
			delta = self.searchtreeview_pressloc[1] - event.y
			if (abs(delta) > 10):
				# start scrolling and disable longpress
				if (self.searchtreeview_longpress_srcid):
					GLib.source_remove(self.searchtreeview_longpress_srcid)
					self.searchtreeview_longpress_srcid = None
				va = self.builder.get_object('vscrolladjustment')
				if (self.searchtreeview_kinetic_prevspeed == 0):
					self.searchtreeview_kinetic_prevspeed = delta/(event.time - self.searchtreeview_presstime)
				else:
					self.searchtreeview_kinetic_prevspeed = (self.searchtreeview_kinetic_prevspeed + delta/(event.time - self.searchtreeview_presstime))/2
				newval = self.searchtreeview_press_adval + delta * self.searchtreeview_kinetic_scroll_factor
				logging.debug('change adjustment value to '+str(newval)+'speed='+str((delta/(event.time - self.searchtreeview_presstime))))
				if (newval > 0 and newval < va.get_upper()):
					va.set_value(newval)
		return False
 
 	def searchtreeview_leave_notify_event(self,widget,event):
 		logging.debug('searchtreeview_leave_notify_event')
 		self.searchtreeview_cancel_all()

	def searchentry_button_press_event_cb(self,widget,event):
		stype = self.searchhistorycombo_get_type()
		if (stype=='folder'):
			return False
		else:
			self.vkeyboard.open_for_entry(widget)
		 	
 	def searchentry_changed_cb(self, widget):
 		text = widget.get_chars(0,-1)
 		stype = self.searchhistorycombo_get_type()
 		logging.debug('searchentrychanged, call new_search')
		self.new_search(stype, 'search:'+urllib.quote(text), 'Search '+stype+' '+text)
 	
 	def searchhistorycombo_changed_cb(self,combo):
 		logging.debug('searchhistorycombo_changed_cb, started')
 		it = combo.get_active_iter()
		sprefixc = self.builder.get_object('searchprefixcombo')
 		if it != None:
			model = combo.get_model()
			slabel, stype, ssearch = model[it]
			if (ssearch==None or ssearch==''):
				sprefixc.show()
				tmp = sprefixc.get_active_text()
				# for a folder only a single letter prefix is valid,
				# for all others we let the users first decide so we make it empty
				if (stype == 'folder' and len(tmp)!=1):
					searchentry = self.builder.get_object('searchentry')
					searchentry.set_text('')
					return
				else:
					if (tmp==''):
						return
					if (len(tmp)==1):
						searchentry = self.builder.get_object('searchentry')
						searchentry.set_text('')
						return
					ssearch = 'search:'+urllib.quote(tmp)
				slabel = None
			else:
				# we have a specificsearch that really is a history entry, so hide the prefix combo
				sprefixc.hide()
			self.new_search(stype, ssearch, slabel)
		else:
			logging.debug('searchhistorycombo_changed_cb, no active iter?')
 	
	def save_search_history(self, specifictype, specificsearch, specificlabel):
		logging.debug('save_search_history, called for '+specificlabel+','+specifictype+','+specificsearch)
		shstore = self.builder.get_object('searchhistorystore')
		#shstore.remove([specificlabel, specifictype, specificsearch])
		shlen = len(shstore)
		shcombo = self.builder.get_object('searchhistorycombo')
		shcombo.handler_block_by_func(self.searchhistorycombo_changed_cb)
		#print 'have',shlen,'items in history'
		for i in xrange(shlen-1,-1,-1):
			#print 'compare',shstore[i][2],shstore[i][0],'at',i,'with',specificsearch,specificlabel
			if (shstore[i][1] == specifictype and shstore[i][2] == specificsearch):
				#print 'items existst at',i,'delete'
				del shstore[i]
		shstore.append([specificlabel, specifictype, specificsearch])
		shlen = len(shstore)
		shcombo.set_active(shlen-1)
		shcombo.handler_unblock_by_func(self.searchhistorycombo_changed_cb)
		logging.debug('have '+str(shlen)+' items, did set '+str(shlen-1)+' active')
		
	def new_search(self, specifictype, specificsearch, specificlabel):
		sprefixc = self.builder.get_object('searchprefixcombo')
		shcombo = self.builder.get_object('searchhistorycombo')
		srs = self.builder.get_object('searchresultstore')
		srs.clear()
		self.search_have_ids = []
		logging.info('specifictype='+str(specifictype)+', specificsearch='+str(specificsearch)+',specificlabel='+str(specificlabel))
		if (specificlabel and specifictype and specificsearch):
			self.save_search_history(specifictype, specificsearch, specificlabel)
		
		if (specificsearch[:7] != 'search:'):
			sprefixc.hide()

		identextra = ''
		if (len(specificsearch)==8 and specificsearch[:7] == 'search:'):
			self.searchprefix = specificsearch[7:8]
			if (specifictype == 'folder'):
				specificsearch = 'folder_id:0'
				identextra = ','+self.searchprefix
		else:
			self.searchprefix = None
		
		# do we have this search in the cache?
		ident = specifictype+','+specificsearch+identextra
		if (self.cache.have_search(ident)):
			self.cache.put_results(ident, srs)
			return

		
		if (specifictype == 'album'):
			self.send_player_command('albums 0 '+str(self.searchbatchsize)+' '+specificsearch+' tags:als')
		elif (specifictype == 'song'):
			self.send_player_command('titles 0 '+str(self.searchbatchsize)+' '+specificsearch+' tags:alT')
		elif (specifictype == 'artist'):
			self.send_player_command('artists 0 '+str(self.searchbatchsize)+' '+specificsearch+' tags:s')
		elif (specifictype == 'folder'):
			self.send_player_command('musicfolder 0 '+str(self.searchbatchsize)+' '+specificsearch)
	
	def searchprefixchanged(self,combo):
		logging.debug('searchprefixchanged, call new_search')
		search = combo.get_active_text()
		if (search==''):
			return
		shcombo = self.builder.get_object('searchhistorycombo')
 		stype = self.searchhistorycombo_get_type()
 		if (len(search)==1):
			label = None
 		else:
 			label = 'Search '+str(stype)+' '+search
		self.new_search(stype, 'search:'+urllib.quote(search), label)
	
	def searchhistorycombo_get_type(self):
		shcombo = self.builder.get_object('searchhistorycombo')
		logging.debug('combo get_active() returns '+str(shcombo.get_active()))
 		it = shcombo.get_active_iter()
 		if it != None:
			model = shcombo.get_model()
			slabel, stype, ssearch = model[it]
			logging.debug('searchhistorycombo_get_type, got'+str(slabel)+','+str(stype)+','+str(ssearch))
			return stype
		logging.debug('searchhistorycombo_get_type, NO ACTIVE ITER')
		return None
	
	def send_playlistcontrol_command(self,command,trackid,albumid,artistid,folderid):
		if (trackid):
			self.send_player_command('playlistcontrol cmd:'+command+' track_id:'+str(trackid))
		if (albumid):
			self.send_player_command('playlistcontrol cmd:'+command+' album_id:'+str(albumid))
		if (artistid):
			self.send_player_command('playlistcontrol cmd:'+command+' artist_id:'+str(artistid))
		if (folderid):
			self.send_player_command('playlistcontrol cmd:'+command+' folder_id:'+str(folderid))
		
	def mi_insert_activate_cb(self,widget):
		searchtreeview = self.builder.get_object('searchtreeview')
		select = searchtreeview.get_selection()
		model,titer = select.get_selected()
		self.send_playlistcontrol_command('insert',model[titer][1],model[titer][2],model[titer][3],model[titer][4])

	def mi_append_activate_cb(self,widget):
		searchtreeview = self.builder.get_object('searchtreeview')
		select = searchtreeview.get_selection()
		model,titer = select.get_selected()
		self.send_playlistcontrol_command('add',model[titer][1],model[titer][2],model[titer][3],model[titer][4])

	def mi_replace_activate_cb(self,widget):
		searchtreeview = self.builder.get_object('searchtreeview')
		select = searchtreeview.get_selection()
		model,titer = select.get_selected()
		self.send_playlistcontrol_command('load',model[titer][1],model[titer][2],model[titer][3],model[titer][4])

	def mi_br_album_activate_cb(self,widget):
		searchtreeview = self.builder.get_object('searchtreeview')
		select = searchtreeview.get_selection()
		model,titer = select.get_selected()
		sublabel = model[titer][0].split('\n')
		self.new_search('album', 'artist_id:'+str(model[titer][3]), 'Albums by '+sublabel[0])

	def mi_so_artist_activate_cb(self,widget):
		searchtreeview = self.builder.get_object('searchtreeview')
		select = searchtreeview.get_selection()
		model,titer = select.get_selected()
		sublabel = model[titer][0].split('\n')
		self.new_search('song', 'artist_id:'+str(model[titer][3]), 'Songs by '+sublabel[0])

	def mi_br_so_album_activate_cb(self,widget):
		searchtreeview = self.builder.get_object('searchtreeview')
		select = searchtreeview.get_selection()
		model,titer = select.get_selected()
		sublabel = model[titer][0].split('\n')
		self.new_search('song', 'album_id:'+str(model[titer][2]), 'Songs on '+sublabel[0])
	
	def mi_browse_folder_activate_cb(self,widget):
		searchtreeview = self.builder.get_object('searchtreeview')
		select = searchtreeview.get_selection()
		model,titer = select.get_selected()
		self.new_search('folder', 'folder_id:'+str(model[titer][4]), 'Folder '+model[titer][0])
		

	def coverPressed(self, widget, data):
		if (self.overlayimage != False):
			return
		overlay = self.builder.get_object('overlay')
		covereventbox = self.builder.get_object('covereventbox')
		overlay.add_overlay(covereventbox)
		covereventbox.show_all()
		self.overlayimage = True

	def largecoverpressed(self, widget, data):
		covereventbox = self.builder.get_object('covereventbox')
		overlay = self.builder.get_object('overlay')
		overlay.remove(covereventbox)
		#covereventbox.hide()
		self.overlayimage = False

	def volumeChanged(self,adj):
		if (not self.updateVolumeLock):
			i = adj.get_value()
			self.send_player_command('mixer volume '+str(round(i)))
	
	def playlistclicked(self, but):
		print 'playlistclicked'
		plistwin = self.builder.get_object('playlistwindow')
		self.plist.clear()
		self.send_player_command('status 0 '+str(self.searchbatchsize)+' tags:aly')
		plistwin.show_all()
	
	def playClicked(self,but):
		if(self.status.mode == 'play'):
			self.send_player_command('mode pause')
		else:
			self.send_player_command('mode play')
	
	def prevClicked(self,but):
		self.send_player_command('playlist index -1')
	
	def nextClicked(self,but):
		self.send_player_command('playlist index +1')
	
	def favfavmet(self,but):
		self.send_player_command('playlist clear')
		self.send_player_command('playlist play /home2/public/playlists/sb/Favoriete%20metal.m3u')

	def favsouljazz(self,but):
		self.send_player_command('playlist clear')
		self.send_player_command('playlist play /home2/public/playlists/sb/Soul%20Funk%20Jazz.m3u')

	def favalgacc(self,but):
		self.send_player_command('playlist clear')
		self.send_player_command('playlist play /home2/public/playlists/sb/Algemeen%20acceptabel.m3u')

	def favolifav(self,but):
		self.send_player_command('playlist clear')
		self.send_player_command('playlist play /home2/public/playlists/sb/Oliviers%20favorieten.m3u')

	def favolinos(self,but):
		self.send_player_command('playlist clear')
		self.send_player_command('playlist play /home2/public/playlists/sb/Nostalgie.m3u')

	def favdrumbass(self,but):
		self.send_player_command('playlist clear')
		self.send_player_command('playlist play /home2/public/playlists/sb/Drum%20and%20Bass.m3u')

	def repeat(self,but):
		if (but.get_active()):
			if (self.status.repeat == 0):
				self.send_player_command('playlist repeat 2')
		else:
			if (self.status.repeat != 0):
				self.send_player_command('playlist repeat 0')
	
	def shuffle(self,but):
		if (but.get_active()):
			if (self.status.shuffle == 0):
				self.send_player_command('playlist shuffle 1')
		else:
			if (self.status.shuffle != 0):
				self.send_player_command('playlist shuffle 0')

	def timeChanged(self,adj):
		if (not self.updateTimeLock):
			tmp = adj.get_value()
			logging.info('new time is '+str(tmp))
			self.send_player_command('time '+str(tmp))

	def __init__(self):
		self.status = sqstatus()
		GObject.threads_init()
		self.builder = Gtk.Builder()
		self.builder.add_from_file('sqgui2.glade')
		self.vkeyboard = vkeyboard(self.builder)
		
		handlers = {
			"songinfo_button_press_event": self.songinfo_button_press_event,
			"songinfo_button_release_event": self.songinfo_button_release_event,
			"mi_mw_al_ar_activate_cb": self.mi_mw_al_ar_activate_cb,
			"mi_mw_so_ar_activate_cb": self.mi_mw_so_ar_activate_cb,
			"mi_mw_so_al_activate_cb": self.mi_mw_so_al_activate_cb,
			"mi_pl_play_activate_cb": self.mi_pl_play_activate_cb,
			"mi_pl_delete_activate_cb": self.mi_pl_delete_activate_cb,
			"pltview_button_press_event_cb": self.pltview_button_press_event_cb,
			"pltview_button_release_event_cb": self.pltview_button_release_event_cb,
			"pltview_motion_notify_event_cb": self.pltview_motion_notify_event_cb,
			"coverpressed": self.coverPressed,
			"largecoverpressed": self.largecoverpressed,
			"volumeChanged": self.volumeChanged,
			"playlistclicked": self.playlistclicked,
			"playClicked": self.playClicked,
			"nextClicked": self.nextClicked,
			"prevClicked": self.prevClicked,
			"closeClicked": self.closeClicked,
			"plcloseclicked": self.plcloseclicked,
			"searchclicked": self.searchclicked,
			"searchcloseclicked": self.searchcloseclicked,
			"searchwindow_delete_event_cb": self.searchwindow_delete_event_cb,
			"playlistwindow_delete_event_cb": self.playlistwindow_delete_event_cb,
			"searchtreeviewactivated": self.searchtreeviewactivated,
			"searchprefixchanged": self.searchprefixchanged,
			"searchtreeview_button_press_event": self.searchtreeview_button_press_event,
			"searchtreeview_button_release_event": self.searchtreeview_button_release_event,
			"searchtreeview_motion_notify_event": self.searchtreeview_motion_notify_event,
			"searchtreeview_leave_notify_event_cb": self.searchtreeview_leave_notify_event,
			"searchentry_button_press_event_cb": self.searchentry_button_press_event_cb,
			"searchentry_changed_cb": self.searchentry_changed_cb,
			"searchhistorycombo_changed_cb": self.searchhistorycombo_changed_cb,
			"mi_insert_activate_cb": self.mi_insert_activate_cb,
			"mi_append_activate_cb": self.mi_append_activate_cb,
			"mi_replace_activate_cb": self.mi_replace_activate_cb,
			"mi_br_album_activate_cb": self.mi_br_album_activate_cb,
			"mi_so_artist_activate_cb": self.mi_so_artist_activate_cb,
			"mi_br_so_album_activate_cb": self.mi_br_so_album_activate_cb,
			"mi_browse_folder_activate_cb": self.mi_browse_folder_activate_cb,
			"timeChanged": self.timeChanged,
			"favalgacc" : self.favalgacc,
			"favsouljazz" : self.favsouljazz,
			"favolinos" : self.favolinos,
			"favolifav" : self.favolifav,
			"favfavmet" : self.favfavmet,
			"favdrumbass" : self.favdrumbass,
			"repeat" : self.repeat,
			"shuffle" : self.shuffle,
			"kbclick": self.vkeyboard.kbclick,
			"kbactivate": self.vkeyboard.kbactivate,
			"kbwindow_delete_event_cb": self.kbwindow_delete_event_cb
		}
		
		self.builder.connect_signals(handlers)
		
		
		window = self.builder.get_object('mainwindow')
		window.connect("delete-event", Gtk.main_quit)
		
		fd = open('sqgui2.css', 'r')
		cssdata = fd.read()
		fd.close()
		provider = Gtk.CssProvider()
		provider.load_from_data(cssdata)
		Gtk.StyleContext.add_provider_for_screen(Gdk.Screen.get_default(),provider,Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)
		
		window.show_all()
		#window.get_window().set_cursor(Gdk.CursorType.BLANK_CURSOR)
		logging.debug('shown windows, call init_idle')
		GLib.idle_add(self.init_idle,0);
	
	def cleanup(self):
		logging.info('kill squeezelite')
		self.procsqueezelite.kill()
		if (self.procssh):
			self.procssh.kill()
		logging.info('cleanup done')

if __name__ == "__main__":
	sg2 = sqgui2()
	Gtk.main()
	sg2.cleanup()
